#TO DO LIST

#Join system
execute as @a[scores={LeaveGame=1..},tag=Playing] if entity @a[tag=Playing,scores={LeaveGame=0}] run function main:leave
scoreboard players set @a LeaveGame 0
execute as @a[tag=!In] at @s run function main:join
execute if entity @a unless entity @a[tag=Playing] as @r[tag=!Playing] run function main:switch

#General setup
effect give @a saturation 100000 0 true 
effect give @e fire_resistance 100000 0 true
effect give @e resistance 100000 30 true
execute as @a[tag=Playing] at @s run tag @a[y=30,dy=10,tag=Playing,tag=Finale2] add Finale3
execute as @a[tag=Playing] at @s if entity @s[y=30,dy=10,tag=!Finale2] run kill @s
execute as @a[tag=Playing] at @s if entity @s[y=30,dy=10,tag=Finale2] run tp @s 8000 200 8000
execute as @e[type=item,nbt={Item:{id:"minecraft:ender_eye"}}] run tag @s add KeepItem
execute as @e[type=item,nbt={Item:{id:"minecraft:diamond_sword"}}] run tag @s add ThrowItem
execute as @e[type=item,nbt={Item:{id:"minecraft:diamond_sword"}}] run tag @s add LavaBlade
execute as @e[type=item,tag=LavaBlade] run data merge entity @s {Age:1s}
execute as @e[type=item,tag=!KeepItem,tag=!ThrowItem] run kill @s
execute as @e[type=item,tag=KeepItem] run data merge entity @s {PickupDelay:0s}
title @a actionbar {"text":""}
clear @a bucket
kill @e[type=minecraft:potion]
xp set @a 0
xp set @a 0 levels

#Death
scoreboard players set @a[tag=Finale3] Death 0
execute as @a[tag=Died] at @s run particle dust 1 0.5 0 1 ~ ~1 ~ 0.5 0.5 0.5 0.1 100 force
execute as @a[tag=Died] at @s run tp @s ~ ~ ~ facing entity @e[tag=Enemy,limit=1,sort=nearest]
execute as @a[scores={Death=1..}] at @s run particle dust 1 0.5 0 1 ~ ~1 ~ 0.5 0.5 0.5 0.1 100 force
tag @a remove Died
execute as @a[scores={Death=1..}] run tag @s add Died
execute as @a[scores={Death=1..}] run clear @s lever
execute as @a[scores={Death=1..}] run clear @s water_bucket
execute as @a[scores={Death=1..}] run clear @s potion
execute as @a[scores={Death=1..}] run clear @s lingering_potion
execute as @a[scores={Death=1..}] run scoreboard players set @s COAS 3
execute as @a[scores={Death=1..}] run scoreboard players set @s Death 0

#Any physical items?
scoreboard players set @a Physical 0
execute as @a[tag=Playing] store result score @s Physical run clear @s #main:physical 0
execute as @a[scores={Physical=1..}] run title @s actionbar {"text":"You are not fully ethereal.","color":"dark_red"}

#Lapis: spawnpoint
execute as @a[tag=Playing] at @s if block ~ ~-1 ~ lapis_block run spawnpoint @a ~ ~ ~
execute as @a[tag=Playing] at @s if block ~ ~-1 ~ lapis_block run title @s actionbar {"text":"Spawnpoint set.","color":"red"}

#Yellow terracotta: get a yellow Key
execute as @a[tag=Playing] at @s if block ~ ~-1 ~ yellow_terracotta unless entity @e[distance=..2,type=item] run give @s[nbt=!{Inventory:[{id:"minecraft:lever"}]}] lever{CustomModelData:1,CanPlaceOn:["gold_block"],display:{Lore:['{"text":"Physical Object","color":"dark_red","italic":"false"}','{"text":"Can open Gold Doors.","color":"gray","italic":"false"}'],Name:'{"text":"Yellow Key","color":"yellow","italic":"false","bold":"true"}'}}

#Green terracotta: get a green Key
execute as @a[tag=Playing] at @s if block ~ ~-1 ~ green_terracotta unless entity @e[distance=..2,type=item] run give @s[nbt=!{Inventory:[{id:"minecraft:lever"}]}] lever{CustomModelData:2,CanPlaceOn:["emerald_block"],display:{Lore:['{"text":"Physical Object","color":"dark_red","italic":"false"}','{"text":"Can open Emerald Doors.","color":"gray","italic":"false"}'],Name:'{"text":"Green Key","color":"green","italic":"false","bold":"true"}'}}

#Red terracotta: get a red Key
execute as @a[tag=Playing] at @s if block ~ ~-1 ~ red_terracotta unless entity @e[distance=..2,type=item] run give @s[nbt=!{Inventory:[{id:"minecraft:lever"}]}] lever{CustomModelData:4,CanPlaceOn:["nether_wart_block"],display:{Lore:['{"text":"Physical Object","color":"dark_red","italic":"false"}','{"text":"Can open Ruby Doors.","color":"gray","italic":"false"}'],Name:'{"text":"Red Key","color":"red","italic":"false","bold":"true"}'}}

#Light Blue terracotta: get a blue Key
execute as @a[tag=Playing] at @s if block ~ ~-1 ~ light_blue_terracotta unless entity @e[distance=..2,type=item] run give @s[nbt=!{Inventory:[{id:"minecraft:lever"}]}] lever{CustomModelData:3,CanPlaceOn:["diamond_block"],display:{Lore:['{"text":"Physical Object","color":"dark_red","italic":"false"}','{"text":"Can open Diamond Doors.","color":"gray","italic":"false"}'],Name:'{"text":"Blue Key","color":"aqua","italic":"false","bold":"true"}'}}

#Blue terracotta: get a Water Bucket
execute as @a[tag=Playing] at @s if block ~ ~-1 ~ blue_terracotta run clear @s bucket

#Orange terracotta: get a Gravity Spell
execute as @a[tag=Playing] at @s if block ~ ~-1 ~ orange_terracotta unless entity @e[distance=..2,type=item] run give @s[nbt=!{Inventory:[{id:"minecraft:splash_potion"}]}] splash_potion{HideFlags:63,display:{Lore:['{"text":"Ethereal Object","color":"dark_aqua","italic":"false"}','{"text":"Raise 1 level while levitating.","color":"gray","italic":"false"}'],Name:'{"text":"Gravity Spell","color":"gold","italic":"false","bold":"true"}'}}

#Gray terracotta: get a Metal Spell
execute as @a[tag=Playing] at @s if block ~ ~-1 ~ gray_terracotta unless entity @e[distance=..2,type=item] run give @s[nbt=!{Inventory:[{id:"minecraft:lingering_potion"}]}] lingering_potion{HideFlags:63,display:{Lore:['{"text":"Ethereal Object","color":"dark_aqua","italic":"false"}','{"text":"Immediately fall while levitating.","color":"gray","italic":"false"}'],Name:'{"text":"Metal Spell","color":"gray","italic":"false","bold":"true"}'}}

#Blue terracotta: get a Water Bucket
execute as @a[tag=Playing] at @s if block ~ ~-1 ~ blue_terracotta unless entity @e[distance=..2,type=item] run give @s[nbt=!{Inventory:[{id:"minecraft:water_bucket"}]}] water_bucket{CanPlaceOn:["blue_concrete"],display:{Lore:['{"text":"Physical Object","color":"dark_red","italic":"false"}','{"text":"Can summon Water streams.","color":"gray","italic":"false"}'],Name:'{"text":"Water Bucket","color":"blue","italic":"false","bold":"true"}'}}

#Remove glass
execute as @a[scores={Physical=0},tag=Playing] at @s run function main:ether

#Add glass
execute as @e[type=area_effect_cloud,name=LightBlueEther,tag=Ether] at @s positioned ~ ~-1 ~ unless entity @a[tag=Playing,distance=..2,scores={Physical=0}] positioned ~ ~1 ~ unless entity @a[tag=Playing,distance=..2,scores={Physical=0}] at @s run setblock ~ ~ ~ light_blue_stained_glass
execute as @e[type=area_effect_cloud,name=GreenEther,tag=Ether] at @s positioned ~ ~-1 ~ unless entity @a[tag=Playing,distance=..2,scores={Physical=0}] positioned ~ ~1 ~ unless entity @a[tag=Playing,distance=..2,scores={Physical=0}] at @s run setblock ~ ~ ~ lime_stained_glass
execute as @e[type=area_effect_cloud,name=RedEther,tag=Ether] at @s positioned ~ ~-1 ~ unless entity @a[tag=Playing,distance=..2,scores={Physical=0}] positioned ~ ~1 ~ unless entity @a[tag=Playing,distance=..2,scores={Physical=0}] at @s run setblock ~ ~ ~ red_stained_glass
execute as @e[type=area_effect_cloud,name=PurpleEther,tag=Ether] at @s positioned ~ ~-1 ~ unless entity @a[tag=Playing,distance=..2,scores={Physical=0}] positioned ~ ~1 ~ unless entity @a[tag=Playing,distance=..2,scores={Physical=0}] at @s run setblock ~ ~ ~ purple_stained_glass
execute as @e[type=area_effect_cloud,name=YellowEther,tag=Ether] at @s positioned ~ ~-1 ~ unless entity @a[tag=Playing,distance=..2,scores={Physical=0}] positioned ~ ~1 ~ unless entity @a[tag=Playing,distance=..2,scores={Physical=0}] at @s run setblock ~ ~ ~ yellow_stained_glass

execute as @e[type=area_effect_cloud,tag=Ether] at @s positioned ~ ~-1 ~ unless entity @a[tag=Playing,distance=..2,scores={Physical=0}] positioned ~ ~1 ~ unless entity @a[tag=Playing,distance=..2,scores={Physical=0}] at @s run kill @s

execute at @e[type=area_effect_cloud,name=LightBlueEther] align xyz run particle dust 0 0.8 1 1 ~0.6 ~0.6 ~0.6 0.2 0.2 0.2 0.1 1 force
execute at @e[type=area_effect_cloud,name=GreenEther] align xyz run particle dust 0 1 0 1 ~0.6 ~0.6 ~0.6 0.2 0.2 0.2 0.1 1 force
execute at @e[type=area_effect_cloud,name=RedEther] align xyz run particle dust 1 0 0 1 ~0.6 ~0.6 ~0.6 0.2 0.2 0.2 0.1 1 force
execute at @e[type=area_effect_cloud,name=PurpleEther] align xyz run particle dust 0.7 0 1 1 ~0.6 ~0.6 ~0.6 0.2 0.2 0.2 0.1 1 force
execute at @e[type=area_effect_cloud,name=YellowEther] align xyz run particle dust 1 1 0 1 ~0.6 ~0.6 ~0.6 0.2 0.2 0.2 0.1 1 force

#Heat

execute as @a[tag=Playing] at @s if block ~ ~ ~ lava run bossbar set minecraft:heat players @a
execute as @a[tag=Playing] at @s if block ~ ~ ~ lava run scoreboard players add @s[scores={Heat=..19}] Heat 1
execute as @a[tag=Playing,tag=FireUpgrade] at @s if block ~ ~ ~ lava run scoreboard players add @s[scores={Heat=20..29}] Heat 1
execute store result bossbar minecraft:heat value run scoreboard players get @a[tag=Playing,limit=1] Heat
execute as @a[tag=Playing] at @s if block ~ ~ ~ water run scoreboard players set @s Heat 0
execute as @a[tag=Playing] at @s if block ~ ~ ~ water run kill @e[type=item,tag=LavaBlade]
give @a[scores={Heat=10..},nbt=!{Inventory:[{id:"minecraft:flint_and_steel"}]}] flint_and_steel{CanPlaceOn:["oak_planks","ice"],Unbreakable:1,display:{Lore:['{"text":"Ethereal Object","color":"dark_aqua","italic":"false"}','{"text":"Concentrate fire to burn blocks.","color":"red","italic":"false"}','{"text":"Cost: 50% Heat.","color":"red","italic":"false"}'],Name:'{"text":"Flame Focus","color":"red","italic":"false","bold":"true"}'},HideFlags:4}
give @a[scores={Heat=20..},nbt=!{Inventory:[{id:"minecraft:iron_axe"}]}] iron_axe{Unbreakable:1,display:{Lore:['{"text":"Ethereal Object","color":"dark_aqua","italic":"false"}','{"text":"Packs a large punch that kills enemies!","color":"red","italic":"false"}','{"text":"Cost: 100% Heat.","color":"red","italic":"false"}'],Name:'{"text":"Fire Blast","color":"red","italic":"false","bold":"true"}'},HideFlags:63}
give @a[scores={Heat=30..},nbt=!{Inventory:[{id:"minecraft:diamond_sword"}]}] diamond_sword{Used:0b,CanDestroy:["cobweb"],Unbreakable:1,display:{Lore:['{"text":"Ethereal Object","color":"dark_aqua","italic":"false"}','{"text":"A ethereal, yet heavy blade...","color":"red","italic":"false"}','{"text":"Likely physical enough to activate systems?","color":"red","italic":"false"}','{"text":"Cost: 150% Heat.","color":"red","italic":"false"}'],Name:'{"text":"Lava Blade","color":"red","italic":"false","bold":"true"}'},HideFlags:63}
execute as @a[scores={Heat=..29}] run clear @s diamond_sword{Used:0b}
execute as @a[scores={Heat=..19}] run clear @s iron_axe
execute as @a[scores={Heat=..9}] run clear @s flint_and_steel
execute as @a[scores={Heat=1..}] at @s if block ~ ~ ~ campfire run effect give @s levitation 2 1 true

#Lava Blade
execute as @e[type=item,tag=LavaBlade] at @s unless entity @a[tag=Playing,distance=..30] run kill @s
execute as @e[type=item,tag=LavaBlade] run data merge entity @s {Item:{tag:{Used:1b}}}
execute as @e[type=item,tag=LavaBlade] run scoreboard players set @a[tag=Playing] Heat 0
execute as @a[tag=Playing,nbt={Inventory:[{tag:{Used:1b}}]}] run tag @s add ReuseBlade
execute as @a[tag=Playing,tag=ReuseBlade] run scoreboard players set @a[tag=Playing] Heat 30
execute as @a[tag=Playing,tag=ReuseBlade] run clear @s diamond_sword
execute as @a[tag=Playing,tag=ReuseBlade] run give @s diamond_sword{Used:0b,Unbreakable:1,display:{Lore:['{"text":"Ethereal Object","color":"dark_aqua","italic":"false"}','{"text":"A ethereal, yet heavy blade...","color":"red","italic":"false"}','{"text":"Cost: 150% Heat.","color":"red","italic":"false"}'],Name:'{"text":"Lava Blade","color":"red","italic":"false","bold":"true"}'},HideFlags:63}
tag @a remove ReuseBlade

#Heat Hits
execute as @a[scores={HeatHit=1..}] at @s run particle flame ~ ~1 ~ 0.5 0.5 0.5 0.01 100 force
execute as @a[scores={HeatHit=1..}] at @s at @e[tag=Enemy,limit=1,sort=nearest] run particle flame ~ ~ ~ 0.5 0.5 0.5 0.01 100 force
execute as @a[scores={HeatHit=1..}] at @s as @e[tag=Enemy,limit=1,sort=nearest] run scoreboard players remove @s Life 1
execute as @a[scores={HeatHit=1..}] at @s as @e[tag=Enemy,limit=1,sort=nearest,type=phantom,scores={Life=0}] run scoreboard players add @s Life 1
execute as @a[scores={HeatHit=1..}] run scoreboard players remove @s Heat 20
execute as @a[scores={HeatHit=1..}] run scoreboard players set @s HeatHit 0

execute as @a[scores={LavaBlade=1..}] at @s run particle flame ~ ~1 ~ 0.5 0.5 0.5 0.01 100 force
execute as @a[scores={LavaBlade=1..}] at @s at @e[tag=Enemy,limit=1,sort=nearest] run particle flame ~ ~ ~ 0.5 0.5 0.5 0.01 100 force
execute as @a[scores={LavaBlade=1..}] at @s as @e[tag=Enemy,limit=1,sort=nearest] run scoreboard players remove @s Life 1
execute as @a[scores={LavaBlade=1..}] run scoreboard players remove @s Heat 30
execute as @a[scores={LavaBlade=1..}] run scoreboard players set @s LavaBlade 0

execute as @a[scores={FlameFocus=1..}] at @s run particle flame ~ ~1 ~ 0.5 0.5 0.5 0.01 100 force
execute as @a[scores={FlameFocus=1..}] run scoreboard players remove @s Heat 10
execute as @a[scores={FlameFocus=1..}] run scoreboard players set @s FlameFocus 0

#Enemy Deaths
execute as @e[type=evoker] at @s if entity @a[tag=Playing,distance=..20] run tp @s ~ ~ ~ facing entity @a[tag=Playing,limit=1]

execute as @e[tag=Enemy,scores={Life=0}] at @s run setblock ~ ~-1 ~ air destroy
execute as @e[tag=Enemy,scores={Life=0},type=evoker] run setblock 192 148 18 red_terracotta
execute as @e[tag=Enemy,scores={Life=0},type=evoker] run tellraw @a[tag=Playing] ["",{"text":"[???] "},{"text":"NO!","color":"aqua","bold":"true"}]
execute as @e[tag=Enemy,scores={Life=0}] at @s run kill @s

#Beacons
execute as @a[tag=Playing] at @s if block ~ ~-1 ~ black_stained_glass run effect give @s jump_boost 1 250 true
execute as @a[tag=Playing] at @s unless block ~ ~-1 ~ black_stained_glass run effect clear @s jump_boost
execute as @a[tag=!BeaconEnergy,nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] at @s run playsound minecraft:block.beacon.activate ambient @a
execute as @a[nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] run setblock 5 65 8 purpur_block
tag @a[nbt={Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] add BeaconEnergy
scoreboard players set @a[tag=!BeaconEnergy] COAS 0
execute as @a[tag=Playing] at @s if block ~ ~-1 ~ beacon run setblock ~ ~-1 ~ black_stained_glass
execute as @a[tag=Playing,tag=BeaconEnergy] at @s if block ~ ~-1 ~ black_stained_glass run give @s[nbt=!{Inventory:[{id:"minecraft:carrot_on_a_stick"}]}] carrot_on_a_stick{Unbreakable:1,display:{Lore:['{"text":"Temporary Power","color":"yellow","italic":"false"}','{"text":"Right-click to activate the Beacon.","color":"gray","italic":"false"}','{"text":"Beacon Energy allows you to fly...","color":"gray","italic":"false"}'],Name:'{"text":"Beacon Energy","color":"gold","italic":"false","bold":"true"}'},HideFlags:63}
execute as @a[tag=Playing] at @s unless block ~ ~-1 ~ black_stained_glass run clear @s carrot_on_a_stick
execute as @a[tag=Playing,scores={COAS=1}] run effect give @s levitation 999999 255 false
execute as @a[tag=Playing,scores={COAS=1}] at @s positioned ~ ~0.5 ~ if block ~ ~-2 ~ black_stained_glass align xyz run tp @s ~0.5 ~-1.5 ~0.5
execute as @a[tag=Playing,scores={COAS=1}] at @s if block ~ ~ ~ water align y run tp @s ~ ~0.3 ~
execute as @a[tag=Playing,scores={COAS=2}] at @s if block ~ ~ ~ water align y run tp @s ~ ~0.3 ~
execute as @a[tag=Playing,scores={COAS=1}] run scoreboard players set @s COAS 2
execute at @a[tag=Playing,scores={COAS=2}] run particle flame ~ ~ ~ 0.3 0.2 0.3 0.01 10 force

execute as @a[tag=Playing,scores={COAS=2,Potion=1..}] at @s run tp @s ~ ~1 ~
execute as @a run scoreboard players set @s Potion 0
execute as @a[tag=Playing,scores={COAS=2,Potion2=1..}] at @s run scoreboard players add @s COAS 1
execute as @a run scoreboard players set @s Potion2 0

execute as @a at @s if entity @s[x=-101,y=101,z=18,distance=100..110,scores={COAS=2}] run scoreboard players set @s COAS 3

execute as @a[tag=Playing,scores={COAS=3..}] run effect clear @s levitation
execute as @a[tag=Playing,scores={COAS=3..}] run scoreboard players set @s COAS 0

#"Cutscenes"
#New chapter
execute as @a[x=21,y=81,z=55,distance=..3,tag=!Chap1,tag=Playing] run title @s title {"text":"Chapter I","color":"red"}
execute as @a[x=21,y=81,z=55,distance=..3,tag=!Chap1,tag=Playing] run title @s subtitle {"text":"Matter","color":"aqua"}
execute as @a[x=21,y=81,z=55,distance=..3,tag=!Chap1,tag=Playing] at @s run playsound cutscene.matter ambient @a ~ ~ ~ 0.5
execute as @a[x=21,y=81,z=55,distance=..3,tag=!Chap1,tag=Playing] run tag @s add Chap1

execute as @a[x=8,y=78,z=-36,distance=..3,tag=!Chap2,tag=Playing] run title @s title {"text":"Chapter II","color":"red"}
execute as @a[x=8,y=78,z=-36,distance=..3,tag=!Chap2,tag=Playing] run title @s subtitle {"text":"Energy","color":"dark_red"}
execute as @a[x=8,y=78,z=-36,distance=..3,tag=!Chap2,tag=Playing] at @s run playsound cutscene.energy ambient @a ~ ~ ~ 0.5
execute as @a[x=8,y=78,z=-36,distance=..3,tag=!Chap2,tag=Playing] run tag @s add Chap2

execute as @a[x=-100,y=75,z=18,distance=..3,tag=!Chap3,tag=Playing] run title @s title {"text":"Chapter III","color":"red"}
execute as @a[x=-100,y=75,z=18,distance=..3,tag=!Chap3,tag=Playing] run title @s subtitle {"text":"Space","color":"dark_purple"}
execute as @a[x=-100,y=75,z=18,distance=..3,tag=!Chap3,tag=Playing] at @s run playsound cutscene.space ambient @a ~ ~ ~ 0.5
execute as @a[x=-100,y=75,z=18,distance=..3,tag=!Chap3,tag=Playing] run tag @s add Chap3

execute as @a[x=67,y=81,z=-20,distance=..3,tag=!Chap4,tag=Playing] run title @s title {"text":"Chapter IV","color":"red"}
execute as @a[x=67,y=81,z=-20,distance=..3,tag=!Chap4,tag=Playing] run title @s subtitle {"text":"Time","color":"yellow"}
execute as @a[x=67,y=81,z=-20,distance=..3,tag=!Chap4,tag=Playing] at @s run playsound cutscene.time ambient @a ~ ~ ~ 0.5
execute as @a[x=67,y=81,z=-20,distance=..3,tag=!Chap4,tag=Playing] run tag @s add Chap4

#End chapter
execute as @a[x=-26,y=115,z=103,distance=..3,nbt={Inventory:[{id:"minecraft:ender_eye"}]}] at @s if block ~ ~-1 ~ redstone_block run fill 7 75 -10 9 73 -10 red_stained_glass replace minecraft:nether_quartz_ore
execute as @a[x=-26,y=115,z=103,distance=..3,nbt={Inventory:[{id:"minecraft:ender_eye"}]}] at @s if block ~ ~-1 ~ redstone_block run particle flame 8 68.5 8 0.4 0.8 0.4 0.01 1000 force
execute as @a[x=-26,y=115,z=103,distance=..3,nbt={Inventory:[{id:"minecraft:ender_eye"}]}] at @s if block ~ ~-1 ~ redstone_block run tp @s 8 68 8

execute as @a[x=-15,y=142,z=-109,distance=..3,nbt={Inventory:[{id:"minecraft:ender_eye"}]}] at @s if block ~ ~-1 ~ redstone_block run particle flame 8 68.5 8 0.4 0.8 0.4 0.01 1000 force
execute as @a[x=-15,y=142,z=-109,distance=..3,nbt={Inventory:[{id:"minecraft:ender_eye"}]}] at @s if block ~ ~-1 ~ redstone_block run tp @s 8 68 8

execute as @a[x=-174,y=141,z=-17,distance=..3,nbt={Inventory:[{id:"minecraft:ender_eye"}]}] at @s if block ~ ~-1 ~ redstone_block run particle flame 8 68.5 8 0.4 0.8 0.4 0.01 1000 force
execute as @a[x=-174,y=141,z=-17,distance=..3,nbt={Inventory:[{id:"minecraft:ender_eye"}]}] at @s if block ~ ~-1 ~ redstone_block run tp @s 8 68 8

execute as @a[x=207,y=149,z=7,distance=..3,nbt={Inventory:[{id:"minecraft:ender_eye"}]}] at @s if block ~ ~-1 ~ redstone_block run setblock 192 148 18 piston[facing=west]
execute as @a[x=207,y=149,z=7,distance=..3,nbt={Inventory:[{id:"minecraft:ender_eye"}]}] at @s if block ~ ~-1 ~ redstone_block run function main:boss/reset
execute as @a[x=207,y=149,z=7,distance=..3,nbt={Inventory:[{id:"minecraft:ender_eye"}]}] at @s if block ~ ~-1 ~ redstone_block run particle flame 8 68.5 8 0.4 0.8 0.4 0.01 1000 force
execute as @a[x=207,y=149,z=7,distance=..3,nbt={Inventory:[{id:"minecraft:ender_eye"}]}] at @s if block ~ ~-1 ~ redstone_block run tp @s 8 68 8

#Lore
tag @a[tag=Playing,x=8,y=68,z=8,distance=..3,scores={Cutscene=..0}] add Cutscene
scoreboard players set @a[tag=Playing,x=8,y=68,z=8,distance=..3,scores={Cutscene=..0}] Cutscene 1
tag @a[tag=Playing,x=8,y=73,z=24,distance=..3,scores={Cutscene=..2}] add Cutscene
scoreboard players set @a[tag=Playing,x=8,y=73,z=24,distance=..3,scores={Cutscene=..2}] Cutscene 3
tag @a[tag=Playing,x=12,y=74,z=33,distance=..3,scores={Cutscene=..4}] add Cutscene
scoreboard players set @a[tag=Playing,x=12,y=74,z=33,distance=..3,scores={Cutscene=..4}] Cutscene 5
tag @a[tag=Playing,x=24,y=80,z=51,distance=..3,scores={Cutscene=..6}] add Cutscene
scoreboard players set @a[tag=Playing,x=24,y=80,z=51,distance=..3,scores={Cutscene=..6}] Cutscene 7
tag @a[tag=Playing,x=-25,y=104,z=24,distance=..3,scores={Cutscene=..8}] add Cutscene
scoreboard players set @a[tag=Playing,x=-25,y=104,z=24,distance=..3,scores={Cutscene=..8}] Cutscene 9
tag @a[tag=Playing,x=4,y=118,z=100,distance=..3,scores={Cutscene=..10}] add Cutscene
scoreboard players set @a[tag=Playing,x=4,y=118,z=100,distance=..3,scores={Cutscene=..10}] Cutscene 11
tag @a[tag=Playing,x=8,y=73,z=-13,distance=..3,scores={Cutscene=..12}] add Cutscene
scoreboard players set @a[tag=Playing,x=8,y=73,z=-13,distance=..3,scores={Cutscene=..12}] Cutscene 13
tag @a[tag=Playing,x=8,y=78,z=-30,distance=..3,scores={Cutscene=..14}] add Cutscene
scoreboard players set @a[tag=Playing,x=8,y=78,z=-30,distance=..3,scores={Cutscene=..14}] Cutscene 15
tag @a[tag=Playing,x=-9,y=128,z=-36,distance=..3,scores={Cutscene=..16}] add Cutscene
scoreboard players set @a[tag=Playing,x=-9,y=128,z=-36,distance=..3,scores={Cutscene=..16}] Cutscene 17
tag @a[tag=Playing,x=3,y=142,z=-102,distance=..7,scores={Cutscene=..18}] add Cutscene
scoreboard players set @a[tag=Playing,x=3,y=142,z=-102,distance=..7,scores={Cutscene=..18}] Cutscene 19
tag @a[tag=Playing,x=-62,y=65,z=46,distance=..3,scores={Cutscene=..20}] add Cutscene
scoreboard players set @a[tag=Playing,x=-62,y=65,z=46,distance=..3,scores={Cutscene=..20}] Cutscene 21
tag @a[tag=Playing,x=-161,y=137,z=4,distance=..3,scores={Cutscene=..22}] add Cutscene
scoreboard players set @a[tag=Playing,x=-161,y=137,z=4,distance=..3,scores={Cutscene=..22}] Cutscene 23

execute if entity @e[type=phantom,scores={Life=3}] run tag @a[tag=Playing,scores={Cutscene=..24}] add Cutscene
execute if entity @e[type=phantom,scores={Life=3}] run scoreboard players set @a[tag=Playing,scores={Cutscene=..24}] Cutscene 25
execute if entity @e[type=phantom,scores={Life=2}] run tag @a[tag=Playing,scores={Cutscene=..26}] add Cutscene
execute if entity @e[type=phantom,scores={Life=2}] run scoreboard players set @a[tag=Playing,scores={Cutscene=..26}] Cutscene 27
execute if entity @e[type=phantom,scores={Life=1}] run tag @a[tag=Playing,scores={Cutscene=..28}] add Cutscene
execute if entity @e[type=phantom,scores={Life=1}] run scoreboard players set @a[tag=Playing,scores={Cutscene=..28}] Cutscene 29

tag @a[tag=Playing,x=28,y=65,z=8,distance=..2,scores={Cutscene=..30}] add Cutscene
scoreboard players set @a[tag=Playing,x=28,y=65,z=8,distance=..2,scores={Cutscene=..30}] Cutscene 31
tag @a[tag=Playing,x=96,y=108,z=41,distance=..3,scores={Cutscene=..32}] add Cutscene
scoreboard players set @a[tag=Playing,x=96,y=108,z=41,distance=..3,scores={Cutscene=..32}] Cutscene 33
tag @a[tag=Playing,x=174,y=148,z=16,distance=..5,scores={Cutscene=..34}] add Cutscene
scoreboard players set @a[tag=Playing,x=174,y=148,z=16,distance=..5,scores={Cutscene=..34}] Cutscene 35

#Finale
execute if block 5 68 11 minecraft:end_portal_frame[eye=true] if block 5 68 5 minecraft:end_portal_frame[eye=true] if block 11 68 5 minecraft:end_portal_frame[eye=true] if block 11 68 11 minecraft:end_portal_frame[eye=true] run tag @a[tag=Playing,tag=!Finale2] add Finale1
tag @a[tag=Playing,tag=Finale1] add Cutscene
tag @a[tag=Playing,tag=Finale3] add Cutscene

execute as @a[x=8,y=75,z=8,distance=..3,tag=Playing] at @s if block ~ ~-1 ~ cracked_stone_bricks run scoreboard players set @a Cutscene 0
execute as @a[x=8,y=75,z=8,distance=..3,tag=Playing] at @s if block ~ ~-1 ~ cracked_stone_bricks run playsound minecraft:entity.wither.break_block ambient @a
execute as @a[x=8,y=75,z=8,distance=..3,tag=Playing] at @s if block ~ ~-1 ~ cracked_stone_bricks run fill 9 74 7 7 74 9 air destroy

execute as @a[tag=Cutscene] run function main:cutscene
execute as @a[tag=GameComplete] run function main:complete

#Phantom boss
execute as @e[tag=Enemy,scores={Life=3},type=phantom] run tp @s -175 146 -2
execute as @e[tag=Enemy,scores={Life=2},type=phantom] run tp @s -176 152 3
execute as @e[tag=Enemy,scores={Life=1},type=phantom] run tp @s -168 137 4
execute as @e[tag=Enemy,scores={Life=1},type=phantom] run bossbar set minecraft:heat max 30
execute as @e[tag=Enemy,scores={Life=1},type=phantom] run setblock 5 65 8 magma_block
execute as @e[tag=Enemy,scores={Life=1},type=phantom] run tag @a[tag=Playing] add FireUpgrade

#Evoker boss
execute as @e[tag=Enemy,scores={Life=6},type=evoker] run function main:boss/phase1
execute as @e[tag=Enemy,scores={Life=4},type=evoker] run function main:boss/phase2
execute as @e[tag=Enemy,scores={Life=2},type=evoker] run function main:boss/phase3

